<template>
  <div class="article-group">
    <div class="article-item">
      <div class="article__title">
        {{ $t(title, {tokens: settings[type].value}) }}
      </div>

      <div class="article__content">
        <div class="article__text">
          {{ $t('bounty.social.paste_your_link') }}
        </div>

        <div class="article-input-wrapper">
          <div class="article__input-link">
            <input type="text" @focus="resetError" data-vv-as="post's link"
              v-validate="`required`"
              data-vv-validate-on="none"
              name="post_link"
              class="article__url"
              placeholder="Paste your post's link here ..."
              v-model="link"
              @keyup.enter="create()"
              v-tooltip="$t(tooltip)"
            >
            <span class="article__btnAdd" @click="create()"></span>
            <br>
            <span class="error show" v-if="errors.has('post_link')">{{ errors.first('post_link') }}</span>
          </div>

          <div class="article__link-group" v-for="item in posts">
            <div class="article__link-item">
              <div class="link">
                {{ item.meta_data }}
              </div>

              <div class="bounty">
                {{ (isApproved(item.status) ? item.heta_tokens : 0 ) | formatCurrencyAmount('heta', '0') }}
              </div>

              <div :class="`status ${item.status}`">
                {{ item.status  | upperFirst }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState } from 'vuex';

import rf from '../../../../common/requests/RequestFactory';

export default {
  props: {
    settings: {
      type: Object,
    },
    tooltip: {
      type: String,
      default: '',
    },
    regex: {
      type: String,
      default: '',
    },
    title: {
      type: String,
    },
    type: {
      type: String,
    },
    posts: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      link: '',
    };
  },
  methods: {
    resetError () {
      this.errors.clear();
    },
    isApproved (status) {
      return status === 'approved';
    },
    create () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = {
            user_id: this.user.id,
            meta_data: this.link,
            type: this.type,
          }
          rf.getRequest('BountyRequest').create(params)
            .then(res => {
              this.link = '';
              this.$emit('created');
            })
            .catch(res => {
              const message = _.chain(res.errors).values().head().value()[0] || 'Error';
              this.$toasted.error(message, {
                position: 'bottom-right',
                duration : 2000
              });
            })
        });
    },
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
};
</script>
<style scoped lang="scss">
  .status {
    font-weight: bold;
    &.pending {
      color: #fcb202;
    }
    &.rejected {
      color: #d0021b;
    }
    &.approved {
      color: #4caf50;
    }
  }
</style>
